'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var he = require('he');
var User = require('./user');
var Photo = require('./photo');

var Status = function () {
  function Status(status) {
    _classCallCheck(this, Status);

    this.created_at = status.created_at;
    this.id = status.id;
    this.rawid = status.rawid;
    this.text = status.text;
    this.source = status.source;
    this.truncated = status.truncated;
    this.in_reply_to_status_id = status.in_reply_to_status_id;
    this.in_reply_to_user_id = status.in_reply_to_user_id;
    this.favorited = status.favorited;
    this.in_reply_to_screen_name = status.in_reply_to_screen_name;
    this.is_self = status.is_self;
    this.location = status.location;
    if (status.hasOwnProperty('repost_status_id')) {
      this.repost_status_id = status.repost_status_id;
    }
    if (status.hasOwnProperty('repost_user_id')) {
      this.repost_user_id = status.repost_user_id;
    }
    if (status.hasOwnProperty('repost_screen_name')) {
      this.repost_screen_name = status.repost_screen_name;
    }
    if (status.hasOwnProperty('repost_status')) {
      this.repost_status = new Status(status.repost_status);
    }
    this.user = new User(status.user);
    if (status.hasOwnProperty('photo')) {
      this.photo = new Photo(status.photo);
    }
    this.type = this._getType();
    this.source_url = this._getSourceUrl();
    this.source_name = this._getSourceName();
    this.txt = this._getTxt();
    this.plain_text = this._getPlainText();
  }

  _createClass(Status, [{
    key: 'isReply',
    value: function isReply() {
      return this.in_reply_to_status_id !== '' || this.in_reply_to_user_id !== '';
    }
  }, {
    key: 'isRepost',
    value: function isRepost() {
      return this.hasOwnProperty('repost_status_id') && this.repost_status_id !== '';
    }
  }, {
    key: 'isOrigin',
    value: function isOrigin() {
      return !(this.isReply() || this.isRepost());
    }
  }, {
    key: 'isOriginRepost',
    value: function isOriginRepost() {
      return this.isOrigin() && this.text.match(/转@/g);
    }
  }, {
    key: '_getType',
    value: function _getType() {
      if (this.isReply()) return 'reply';
      if (this.isRepost()) return 'repost';
      if (this.isOrigin()) return 'origin';
      return 'unknown';
    }
  }, {
    key: '_getSourceUrl',
    value: function _getSourceUrl() {
      if (this.source.match(/<a href=\"(.+)\" target=\"_blank\">.+<\/a>/)) {
        return this.source.match(/<a href=\"(.+)\" target=\"_blank\">.+<\/a>/)[1];
      } else {
        return '';
      }
    }
  }, {
    key: '_getSourceName',
    value: function _getSourceName() {
      if (this.source.match(/<a href=\".+\" target=\"_blank\">(.+)<\/a>/)) {
        return this.source.match(/<a href=\".+\" target=\"_blank\">(.+)<\/a>/)[1];
      } else {
        return this.source;
      }
    }
  }, {
    key: '_getTxt',
    value: function _getTxt() {
      var pattern = /[@#]?<a href=\"(.*?)\".*?>(.*?)<\/a>#?/g;
      var match = this.text.match(pattern);
      var txt = [];
      var theText = this.text;
      if (match) {
        match.forEach(function (item) {
          var index = theText.indexOf(item);
          if (index > 0) txt.push({ type: 'text', text: he.decode(theText.substr(0, index)) });
          if (item.substr(0, 1) === '#') {
            var matchText = item.match(/#<a href=\".*?\".?>(.*?)<\/a>#/);
            txt.push({
              type: 'tag',
              text: '#' + he.decode(matchText[1]) + '#',
              query: he.decode(matchText[1])
            });
          }
          if (item.substr(0, 1) === '@') {
            var _matchText = item.match(/@<a href=\"http:\/\/fanfou.com\/(.*?)\".*?>(.*?)<\/a>/);
            txt.push({
              type: 'at',
              text: '@' + he.decode(_matchText[2]),
              name: he.decode(_matchText[2]),
              id: _matchText[1]
            });
          }
          if (item.substr(0, 1) === '<') {
            var _matchText2 = item.match(/<a href=\"(.*?)\".*?>(.*?)<\/a>/);
            txt.push({
              type: 'link',
              text: _matchText2[2],
              link: _matchText2[1]
            });
          }
          theText = theText.substr(index + item.length);
        });
        if (theText.length) txt.push({
          type: 'text',
          text: he.decode(theText)
        });
        return txt;
      } else {
        return [{ type: 'text', text: he.decode(theText) }];
      }
    }
  }, {
    key: '_getPlainText',
    value: function _getPlainText() {
      var text = '';
      this.txt.forEach(function (t) {
        text += t.text;
      });
      return he.decode(text);
    }
  }]);

  return Status;
}();

module.exports = Status;